﻿-------------------------- DEFINE USER SLASH COMMANDS ------------------------

SLASH_G910CAL1         = "/G910calibrate"	-- used to place calibration pattern on the screen for 30 seconds
SLASH_G910CAL2         = "/G910cal"
SLASH_G910RESET1       = "/G910reset"		-- tell the app to reset the lights
SLASH_G910RESET2       = "/G910r"
SLASH_G910CDRESET1     = "/G910cdreset"		-- reset all the cooldown lights, take 12 seconds to process
SLASH_G910CDRESET2     = "/G910cdr"
SLASH_G910PROFILE11    = "/G910profile1"	-- activate color profile 1
SLASH_G910PROFILE21    = "/G910profile2"	-- activate color profile 2
SLASH_G910PROFILESWAP1 = "/G910profileswap"	-- toggle color profile
SLASH_G910TRIGGER1     = "/G910trigger"		-- for testing only
SLASH_G910ACTIONBARS1  = "/G910actionbars"	-- user preference to suppress action bar messages

-------------------------- ADD-ON GLOBALS ------------------------

G910inCalibrationMode = 0				--  flag to suspend event processing (and update user message)
G910calCountdown = 0
G910chatInputOpen = false				--  flag to know chat window state and if just changed
G910whisperLight = false				--  flag to not send unnecessary stopChatLights
G910cinematicMovieMode = false			--  flag to come out of movie mode upon moving
G910spuriousEventMuteCountdown = 1.0	--  used to surpress unwanted events firing just after character log in
G910changeSpecCooldown = 0				--  used to suspend cooldown key updates when everything changes at once
G910wasMoney = 0						--  used to tell if money is coming in or going out
G910oldSpecialization = 0				--  used to tell if spec changed or just a talent (new for 7.0)
G910isAtForge = false					--  used to track if artifact forge is open or closed (1.6 add)
G910artifactPower = 0					--  used to track artifact power to know if it changes (1.6 add)
G910sendExtraAliveSignal = false		--  sends an extra alive signal to overcome load screen block (1.11 add)
G910playerOutOfControlEvent = false		--  used as back-up method to prevent short-term inactive ability msgs (1.7 add)
G910playerInCombat = false				--  used for echoed notification (1.14 add)
G910playerDead = false					--  used for echoed notification (1.14 add)
G910cooldownMark = {0,0,0,0,0,0,0,0,0,0,0,0,	-- know what's been flagged as on cooldown so won't send again
					0,0,0,0,0,0,0,0,0,0,0,0,
					0,0,0,0,0,0,0,0,0,0,0,0}
--G910SuppressCooldowns 				--  saved variable in the .toc (applies across all characters)

-------------------------- THE SLASH COMMANDS EXECUTE CODE HERE ------------------------

SlashCmdList["G910CAL"] = function(msg, theEditFrame)		--  /G910calibrate
	ChatFrame1:AddMessage( "G910xmit is in calibration mode for the next 30 seconds.")
	G910pendingMessage = ""				--reset the message systemn
	G910XmitPhase = 1
	G910XmitCounter = 0
	G910chatInputOpen = false			--forget the chat window was open (so "e" doesn't fire after 30 sec)
	G910SetupGuardPixels()
	G910GuardPixels(0)
	G910xmitD1Texture:SetTexture("Interface\\AddOns\\G910xmit\\02")	-- calibration pattern
	G910xmitD2Texture:SetTexture("Interface\\AddOns\\G910xmit\\01")
	G910xmitD3Texture:SetTexture("Interface\\AddOns\\G910xmit\\03")
	G910xmitD4Texture:SetTexture("Interface\\AddOns\\G910xmit\\04")
	G910xmitD5Texture:SetTexture("Interface\\AddOns\\G910xmit\\05")
	G910xmitD6Texture:SetTexture("Interface\\AddOns\\G910xmit\\07")
	G910xmitD7Texture:SetTexture("Interface\\AddOns\\G910xmit\\06")
	G910inCalibrationMode = 3
	G910calCountdown = 30.0
end

SlashCmdList["G910RESET"] = function(msg, theEditFrame)		--  /G910reset    Reset all the flashing lights
	ChatFrame1:AddMessage( "G910xmit: Sending reset signal to WoW G910.")
	G910pendingMessage = ""				--reset the message system
	G910XmitPhase = 1
	G910XmitCounter = 0
	G910SendMessage("R")
	G910whisperLight = false
	G910sendExtraAliveSignal = false
	G910playerOutOfControlEvent = false
	G910playerInCombat = false
	G910playerDead = false
end

SlashCmdList["G910CDRESET"] = function(msg, theEditFrame)		--  /G910cdreset    Send full set of action bar status msgs
	if G910SuppressCooldowns then
		ChatFrame1:AddMessage( "G910xmit is set to ignore action bar updates. Type \"/G910actionbars on\" to enable.")
	else
		ChatFrame1:AddMessage( "G910xmit: Resetting all keyboard lights for action bars.")
		resetTheCooldowns()
	end
end

SlashCmdList["G910PROFILE1"] = function(msg, theEditFrame)		--  /G910profile1    Activate lighting profile
	G910SendMessage("P")
end

SlashCmdList["G910PROFILE2"] = function(msg, theEditFrame)		--  /G910profile2    Activate lighting profile
	G910SendMessage("Q")
end

SlashCmdList["G910PROFILESWAP"] = function(msg, theEditFrame)		--  /G910profileswap    Activate lighting profile
	G910SendMessage("p")
end

SlashCmdList["G910TRIGGER"] = function(msg, theEditFrame)		-- send arbitrary command for testing
	ChatFrame1:AddMessage( "G910xmit: Sending ‘"..msg.."’ to WoW G910.")
	G910SendMessage(msg)
end

SlashCmdList["G910ACTIONBARS"] = function(msg, theEditFrame)		-- to send, or not, cooldown updates (added in 1.10)
	if msg == "off" then
		G910SuppressCooldowns = true
		ChatFrame1:AddMessage("G910xmit will ignore action bar updates. Uncheck \"Show action bar cooldowns\" in WoW G910.")
	elseif msg == "on" then
		G910SuppressCooldowns = false
		ChatFrame1:AddMessage("G910xmit will track and send all action bar update messages. Enable 'Show action bar cooldowns' in WoW G910.")
	else
		if G910SuppressCooldowns then
			ChatFrame1:AddMessage("G910xmit is ignoring action bar changes. Type again with \"on\" to enable.")
		else
			ChatFrame1:AddMessage("G910xmit is sending action bar updates. Type again with \"off\" to disable.")
		end
	end
end

-------------------------- PLUG INTO EVENTS OF INTEREST ------------------------

function G910xmit_OnLoad(frame)
	frame:RegisterEvent("PLAYER_ENTERING_WORLD")	-- environment ready
	
	frame:RegisterEvent("PLAYER_REGEN_ENABLED")		-- out of combat
	frame:RegisterEvent("PLAYER_REGEN_DISABLED")	-- into combat
	
	frame:RegisterEvent("CINEMATIC_START")			-- Only fires for cinematics using in-game engine, not pre-rendered movies
	frame:RegisterEvent("CINEMATIC_STOP")
	frame:RegisterEvent("PLAY_MOVIE")				-- fires for pre-rendered movies but has no "done with movie" call
	
	frame:RegisterEvent("PLAYER_MONEY") 			-- player gains or loses money

	frame:RegisterEvent("ACHIEVEMENT_EARNED")
	frame:RegisterEvent("PLAYER_LEVEL_UP")

	frame:RegisterEvent("PLAYER_ALIVE")  			-- both release from death to a graveyard AND accept a rez before releasing spirit; fires at login too
	frame:RegisterEvent("PLAYER_UNGHOST") 			-- back to life after being a ghost (but not if accept player rez)
	frame:RegisterEvent("PLAYER_DEAD") 				-- player just died
	
	frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")-- player switches talent builds. in 7.0, this triggers every time a talent is changed

	frame:RegisterEvent("CHAT_MSG_WHISPER")			-- player receives a whisper from another player's character.
	frame:RegisterEvent("CHAT_MSG_BN_WHISPER")		-- Fires when you receive a whisper though Battle.net
	frame:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")-- Fires everytime you send a whisper though Battle.net
	frame:RegisterEvent("PLAYER_STARTED_MOVING")	-- started forward/backward/strafe. Not jumping, turning, or taking a taxi.
	
	frame:RegisterEvent("READY_CHECK")				-- ready check is triggered.

	frame:RegisterEvent("DUEL_REQUESTED")			-- these next 5 added in 1.6
	frame:RegisterEvent("HEARTHSTONE_BOUND")
	frame:RegisterEvent("TRANSMOGRIFY_SUCCESS")
	frame:RegisterEvent("ARTIFACT_UPDATE")
	frame:RegisterEvent("ARTIFACT_CLOSE")
	
	frame:RegisterEvent("PLAYER_CONTROL_GAINED")	-- try and avoid dimming cooldowns for short-term events; 1.7 add
	frame:RegisterEvent("PLAYER_CONTROL_LOST")
	
	G910XmitPhase = 1
	G910XmitDelay = 5
	G910XmitCounter = 0
	G910XmitMinTransmitDelay = 0.015		-- "seemed to be right", added in 1.12
	G910XmitTransmitCounter = 0
	
	G910pendingMessage = ""
end

-------------------------- EVENT ROUTINES CALLED BY WOW ------------------------

function G910xmit_OnEvent(frame, event, ...)
--	local arg1, arg2, _, _, _, arg6 = ...;
	if (G910inCalibrationMode == 0) then
		if event == "PLAYER_ENTERING_WORLD" then		-- set stuff up
			G910xmit:Show()
			G910SetupGuardPixels()
			G910GuardPixels(0)
			G910spuriousEventMuteCountdown = 2.0
			G910wasMoney = GetMoney()
			G910oldSpecialization = GetSpecialization()
			G910isAtForge = false			
			G910SendMessage("e")					-- send message chat field has closed (fix for /reload, new in 1.11)
			G910chatInputOpen = false				-- and remember it's closed
		elseif event == "PLAYER_STARTED_MOVING" then	-- Clear the whisper light & movie mode upon moving.
			if G910sendExtraAliveSignal then
				G910SendMessage("U")					-- added in 1.11
				G910sendExtraAliveSignal = false
			end
			if G910whisperLight then
				G910SendMessage("i")
				G910whisperLight = false
			end
			if G910cinematicMovieMode then
				G910SendMessage("V")
				G910cinematicMovieMode = false
			end
		elseif event == "PLAYER_CONTROL_LOST" then		-- added in 1.7
			G910playerOutOfControlEvent = true
		elseif event == "PLAYER_CONTROL_GAINED" then	-- added in 1.7
			G910playerOutOfControlEvent = false
		elseif event == "PLAYER_REGEN_DISABLED" then	-- Into combat
			G910SendMessage("C")
			G910playerInCombat = true
		elseif event == "PLAYER_REGEN_ENABLED" then		-- Out of combat
			G910SendMessage("O")
			G910playerInCombat = false
			C_Timer.After(7, G910extraOutOfCombat)  -- after 7 seconds, send it again (1.14 add)
		elseif event == "TRANSMOGRIFY_SUCCESS" then		-- added in 1.6
			searchAndDestroy("J")						-- added in 1.8 to stop multiple plays
			G910SendMessage("J")
		elseif event == "PLAYER_MONEY" then				-- Money changed hands
			local moneyGain = GetMoney() - G910wasMoney
			if     (moneyGain <= -10000) 				      then G910SendMessage("g")
			elseif (moneyGain > -10000 and moneyGain <= -100) then G910SendMessage("s") 
			elseif (moneyGain > -100 and moneyGain < 0) 	  then G910SendMessage("m") 
			elseif (moneyGain > 0 and moneyGain < 100) 		  then G910SendMessage("M") 
			elseif (moneyGain >= 100 and moneyGain < 10000)   then G910SendMessage("S") 
			else						 					  	   G910SendMessage("G")
			end
			G910wasMoney = GetMoney()
		elseif event == "ACHIEVEMENT_EARNED" then		-- a cheesement
			G910SendMessage("A")
		elseif event == "PLAYER_LEVEL_UP" then			-- Ding!
			G910SendMessage("A")
		elseif event == "PLAYER_ALIVE" then				-- got player rez while face-down -OR- released to graveyard & still dead
			if ((UnitIsDeadOrGhost("player") == false) or (UnitIsDeadOrGhost("player") == nil)) then   -- 2.2 tweak
													 	-- because ==1 means must have released to graveyard but is actually still dead
				G910SendMessage("U")
				G910sendExtraAliveSignal = true		 -- this one used by player_started_moving
				G910changeSpecCooldown = 75			 -- let things settle before updating cooldowns
				G910playerDead = false
				C_Timer.After(7,G910extraAliveAgain) -- send it again after 7 seconds (1.14 add)
			end											
		elseif event == "PLAYER_UNGHOST" then			-- transition from ghost form to alive after running back to corpse or spirit healer
			G910SendMessage("U")						--   changed in 2.2
			G910changeSpecCooldown = 75				-- let things settle before updating cooldowns
			G910playerDead = false
			C_Timer.After(7,G910extraAliveAgain)  -- send it again after 7 seconds (1.14 add)
		elseif event == "PLAYER_DEAD" then				-- Stood in the fire
			G910SendMessage("D")
			G910playerDead = true
		elseif event == "READY_CHECK" then				-- Leeeeeeroyyyyyy!!!
			G910SendMessage("H")
		elseif event == "DUEL_REQUESTED" then			-- added in 1.6
			G910SendMessage("H")
		elseif event == "HEARTHSTONE_BOUND" then		-- added in 1.6
			G910SendMessage("h")
		elseif event == "CINEMATIC_START" then			-- Into a movie -- fires for new character in-game movie, garrison building reveal, etc.
			if G910cinematicMovieMode == false then			-- does not fire for in-game pre-renders like Lich King death
				G910SendMessage("W")
				G910cinematicMovieMode = true
			end
		elseif event == "CINEMATIC_STOP" then			-- Out of an in-game movie
			G910SendMessage("V")
			G910cinematicMovieMode = false
		elseif event == "PLAY_MOVIE" then				-- Fires for in-game pre-rendered movies, like WoD end-of-zone movies. No "done" signal
			if G910cinematicMovieMode == false then			-- don't send second darken signal if one already went (player might stack movie plays)
				G910SendMessage("W")
				G910cinematicMovieMode = true
			end
		elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then-- changed spec
			if G910spuriousEventMuteCountdown == 0 then		-- an extra one fires at log in; ignore it
				if GetSpecialization() ~= G910oldSpecialization then	-- ignore if only a talent change but not a spec change
					G910SendMessage("T")						-- when spec changes, play the animation first then wait and update all cooldowns.
					G910changeSpecCooldown = 200				-- empirical value; too short and extra cooldown updates fire; too long and valid cooldowns missed
					G910oldSpecialization = GetSpecialization()
				end
			end
		elseif event == "CHAT_MSG_WHISPER" then			-- Got a whisper
			if not G910whisperLight then
				G910SendMessage("I")
				G910whisperLight = true
			end
		elseif event == "CHAT_MSG_BN_WHISPER" then		-- Got a Battle.net whisper
			if not G910whisperLight then
				G910SendMessage("I")
				G910whisperLight = true
			end
		elseif event == "CHAT_MSG_BN_WHISPER_INFORM" then-- player sent a battlenet whisper, so cancel whisper light
			if G910whisperLight then
				G910SendMessage("i")
				G910whisperLight = false
			end
		elseif event == "ARTIFACT_UPDATE" then			-- added in 1.6
			if C_ArtifactUI.IsAtForge()	then		-- Only if player is currently at the forge...
				if G910isAtForge then  				-- if this update is happening while the forge is open
					local newPower = C_ArtifactUI.GetTotalPurchasedRanks()
					if newPower > G910artifactPower then	-- and the power has increased, play upgrade animation
						G910SendMessage("a")
						G910artifactPower = newPower
					end
				else								-- if we were not previously at the forge, play opening forge animation
					G910SendMessage("F")
					G910isAtForge = true
					G910artifactPower = C_ArtifactUI.GetTotalPurchasedRanks()
				end
			end
		elseif event == "ARTIFACT_CLOSE" then			-- added in 1.6
			if G910isAtForge then  				-- if we were at the forge, then play animation
				G910SendMessage("f")
				G910isAtForge = false
			end
		end
	end
end

function G910xmit_OnUpdate(frame, elapsed)
	if G910spuriousEventMuteCountdown > 0 then
		G910spuriousEventMuteCountdown = G910spuriousEventMuteCountdown - elapsed
		if G910spuriousEventMuteCountdown < 0 then
			G910spuriousEventMuteCountdown = 0
		end
	end

	if G910XmitCounter > 0 then						--we're sending a message
		G910XmitTransmitCounter = G910XmitTransmitCounter  + elapsed
		if G910XmitTransmitCounter >= G910XmitMinTransmitDelay then		-- added in 1.12 to stop high frame rate from breaking messages
			G910XmitTransmitCounter = 0
		   	G910XmitCounter = G910XmitCounter - 1
			if G910XmitCounter <= 0 then					--phase just timed out
				if G910XmitPhase == 3 then						--done with first signal
					G910GuardPixels(1)
					G910XmitPhase = 2
					G910XmitCounter = G910XmitDelay
				elseif G910XmitPhase == 2 then					--done with second signal
					G910GuardPixels(0)
					G910XmitPhase = 1
					G910XmitCounter = G910XmitDelay
				end
			end
		end

	elseif string.len(G910pendingMessage) > 0 then				--else, we can fetch & post the next message
			nextMessage = string.sub(G910pendingMessage,1,1)
			if nextMessage == "!" then 
				color = string.sub(G910pendingMessage,2,2)
				nextMessage = string.sub(G910pendingMessage,3,3)
				G910pendingMessage = string.sub(G910pendingMessage,3)	--remove first two chars
				putMsgOnPixels(nextMessage,color)
			else
				putMsgOnPixels(nextMessage)
			end
			G910GuardPixels(0)
			G910pendingMessage = string.sub(G910pendingMessage,2,-1)	--remove first char (or if color msg, the third)
			G910XmitPhase = 3
			G910XmitCounter = G910XmitDelay
			G910XmitTransmitCounter = 0

	elseif G910calCountdown > 0 then							--else we could be in calibration mode
		G910calCountdown = G910calCountdown - elapsed
		if ( (G910inCalibrationMode==3) and (G910calCountdown<20) ) then
			ChatFrame1:AddMessage( "G910xmit is in calibration mode for the next 20 seconds.")
			G910inCalibrationMode = 2
		elseif ( (G910inCalibrationMode==2) and (G910calCountdown<10 ) ) then
			ChatFrame1:AddMessage( "G910xmit is in calibration mode for the next 10 seconds.")
			G910inCalibrationMode = 1			
		elseif ( G910calCountdown <= 0 ) then
			G910calCountdown = 0
			ChatFrame1:AddMessage( "G910xmit is now out of calibration mode.")
			G910inCalibrationMode = 0
		end
	end
	
	if ( G910SuppressCooldowns ~= true) then				-- v1.10 add; speed things up (a tiny bit) if cooldowns aren't wanted.
		if ( shouldTheCooldownsBeSuspended()==false ) then -- ignore cooldowns while on a taxi, out of control, or dead
			if G910changeSpecCooldown > 0 then									-- if recently did spec change, ignore cooldown updates for a while
				G910changeSpecCooldown = G910changeSpecCooldown - 1
				if G910changeSpecCooldown == 0 then
					resetTheCooldowns()												-- then update them all
				end
			else
				updateTheCooldowns()											-- if no recent spec change, do normal scan for any changes
			end
		end
	end
	
	if G910calCountdown == 0 then
		if GetCurrentKeyBoardFocus() == nil then		-- is a typing window open for input? (no window = nil)
			if G910chatInputOpen == true then			-- if no typing field has focus, then if I think one does,
				G910SendMessage("e")					-- send message chat field has closed
				G910chatInputOpen = false				-- and remember it's closed
			end
		else
			if G910chatInputOpen == false then			-- if a typing field has focus, but didn't before,
				G910SendMessage("E")					-- send message chat field has opened
				G910chatInputOpen = true				-- and remember it's open
			end
		end
	end
end

-------------------------- UTILITY FUNCTION FOR BETTER PERFORMANCE ----------------

function G910extraOutOfCombat()		-- gets called 5 seconds after first out-of-combat signal
	if G910playerInCombat then
		-- don't send the message
	else
		G910SendMessage("O")
	end
end

function G910extraAliveAgain()		-- gets called 5 seconds after first rez signal
	if G910playerDead then
		-- don't send the message
	else
		G910SendMessage("U")
	end
end

-------------------------- CUSTOM CODE TO TAP OUT THE BITS ------------------------

function putMsgOnPixels(msg,color)		-- color is nil when this is called with just putMsgOnPixels(msg)
	--ChatFrame1:AddMessage("putting "..msg.." on the color pixels using color "..tostring(color))
	bitmask = 1
	texture = "07"			-- use white pixels when color is nil
	if color == "R" then 
		texture = "01" 
	elseif color == "G" then 
		texture = "02" 
	elseif color == "B" then 
		texture = "03" 
	end
	theCode = string.byte(msg)
	--print("analyzing byte" .. theCode)
	for i = 1,7 do
		if bit.band(theCode,bitmask) > 0 then		-- uses C library that Blizzard included
			_G["G910xmitD"..i.."Texture"]:SetTexture("Interface\\AddOns\\G910xmit\\"..texture)
		else
			_G["G910xmitD"..i.."Texture"]:SetTexture("Interface\\AddOns\\G910xmit\\00")
		end	
		bitmask = bitmask * 2						-- proven faster than bit shifting
	end
end


function G910SendMessage(message)
	--print("in G910SendMessage with "..message)
	if message == "T" then						-- have spec change jump ahead of cooldown changes that leak thru
		G910pendingMessage = message				-- in fact, purge everything else since spec change happens when it's "quiet"
	else
		if message == "C" or message == "O" or message == "e" then			-- prioritize combat and chat close
			G910pendingMessage = message .. G910pendingMessage
		else
			G910pendingMessage = G910pendingMessage .. message
			--print("G910pendingMessage = "..G910pendingMessage)
		end
	end
	--print ("Added <"..message.."> message; pendingMessage length now "..string.len(G910pendingMessage) )
end

function G910GuardPixels(state)
	if state == 0 then
		G910xmitR2Texture:SetTexture("Interface\\AddOns\\G910xmit\\00")
		G910xmitL2Texture:SetTexture("Interface\\AddOns\\G910xmit\\00")
	else
		G910xmitR2Texture:SetTexture("Interface\\AddOns\\G910xmit\\07")
		G910xmitL2Texture:SetTexture("Interface\\AddOns\\G910xmit\\01")
	end	
end
	
function G910SetupGuardPixels ()		
	G910xmitR1Texture:SetTexture("Interface\\AddOns\\G910xmit\\07")
	G910xmitR3Texture:SetTexture("Interface\\AddOns\\G910xmit\\07")
	
	G910xmitL1Texture:SetTexture("Interface\\AddOns\\G910xmit\\01")
	G910xmitL3Texture:SetTexture("Interface\\AddOns\\G910xmit\\01")
end

-------------------------- CUSTOM CODE TO TRACK AND UPDATE ACTION BARS ------------------------

function updateTheCooldowns()		-- look at all action bar slots and send message for any that changed since last scan
	local offset = 0
	if GetBonusBarOffset() > 0 then
		offset = 12*(GetBonusBarOffset()+5)	-- looks at rogue stealth bars, shadow priest bars, warrior stances, and druid forms(?)
	end
	for i = 1,12 do
		if shouldTheCooldownsBeSuspended() then break end
				-- some griffin rides and losses of control were leaking thru. This will (should) fix that; added in 1.4

		_,hasCooldown,_ = GetActionCooldown(i+offset)		-- ActionBar1 (1 thru =)
		
		if IsUsableAction(i+offset) and hasCooldown<1.5 then			-- if slot i of AB1 is usable and no cooldown
			if G910cooldownMark[i] == 1 then								--   and is marked as on-cooldown
				G910cooldownMark[i] = 0										--     then unmark it
				if not searchAndDestroy("!R" .. string.char(i+48)) then		--     if the opposite msg isn't pending
					msg = "!R" .. string.char(i+48+16)     -- send as red pixels, A B C D E F G H I J K L
					G910SendMessage(msg)
				end
			end
		else																-- if not usable or cooling down
			if G910cooldownMark[i] == 0 then								--   and not marked as cooling down
				G910cooldownMark[i] = 1										--     mark it
				if not searchAndDestroy("!R" .. string.char(i+48+16)) then
					msg = "!R" .. string.char(i+48)     -- send as red pixels, 1 2 3 4 5 6 7 8 9 : ; <
					G910SendMessage(msg)
				end
			end
		end

		_,hasCooldown,_ = GetActionCooldown(i+60)	-- ActionBar6 = above AB1  (F1 thru F10 with gaps)
		if IsUsableAction(i+60) and hasCooldown<1.5 then
			if G910cooldownMark[i+12] == 1 then
				G910cooldownMark[i+12] = 0
				if not searchAndDestroy("!G" .. string.char(i+48)) then
					msg = "!G" .. string.char(i+48+16)     -- send as green pixels, A B C D E F G H I J K L
					G910SendMessage(msg)
				end
			end
		else
			if G910cooldownMark[i+12] == 0 then
				G910cooldownMark[i+12] = 1
				if not searchAndDestroy("!G" .. string.char(i+48+16)) then
					msg = "!G" .. string.char(i+48)     -- send as green pixels, 1 2 3 4 5 6 7 8 9 : ; <
					G910SendMessage(msg)
				end
			end
		end

		if i <= 6 then
			_,hasCooldown,_ = GetActionCooldown(i+48)	-- ActionBar5 = to right of AB6 (F11 thru "F15")
			if IsUsableAction(i+48) and hasCooldown<1.5 then
				if G910cooldownMark[i+24] == 1 then
					G910cooldownMark[i+24] = 0
					if not searchAndDestroy("!B" .. string.char(i+48)) then
						msg = "!B" .. string.char(i+48+16)     -- send as blue pixels, A B C D E F G H I J K L
						G910SendMessage(msg)
					end
				end
			else
				if G910cooldownMark[i+24] == 0 then
					G910cooldownMark[i+24] = 1
					if not searchAndDestroy("!B" .. string.char(i+48+16)) then
						msg = "!B" .. string.char(i+48)     -- send as blue pixels, 1 2 3 4 5 6 7 8 9 : ; <
						G910SendMessage(msg)
					end
				end
			end
		end 
	end
end


function shouldTheCooldownsBeSuspended()
	local suspendThem = false
	if ( G910playerOutOfControlEvent or
	     UnitOnTaxi("player") or
	     C_LossOfControl.GetNumEvents() > 0 or
	     UnitIsDeadOrGhost("player") or
	     HasVehicleActionBar() or				-- these 3 adds in 1.10 from Tuller and zork on the wowinterface.com forums
	     HasOverrideActionBar() or						-- this for Darkmoon Fair cannon & shooting gallery
	     HasTempShapeshiftActionBar() ) then 
	     	suspendThem = true 
	end
	return  suspendThem
end


function searchAndDestroy(theMsg)		-- retuns true if theMsg found and removed
	local count = 0
	local wasFound = false
	G910pendingMessage, count = string.gsub(G910pendingMessage, theMsg, "", 1)	-- replace one of theMsg with nothing
	if count > 0 then
		wasFound = true
	end
	return wasFound
end

function resetTheCooldowns()		-- this will send 30 messages of 2 chars each; 12 seconds to process (as of 0.93)
	local offset = 0
	if GetBonusBarOffset() > 0 then
		offset = 12*(GetBonusBarOffset()+5)	-- looks at rogue stealth bars, shadow priest bars, warrior stances, and druid forms(?)
	end
	for i = 1,12 do
		_,hasCooldown,_ = GetActionCooldown(i+offset)		-- ActionBar1 (1 thru =)
		if IsUsableAction(i+offset) and hasCooldown<1.5 then
			G910cooldownMark[i] = 0
			msg = "!R" .. string.char(i+48+16)     -- send as red pixels, A B C D E F G H I J K L
			G910SendMessage(msg)
		else
			G910cooldownMark[i] = 1
			msg = "!R" .. string.char(i+48)     -- send as red pixels, 1 2 3 4 5 6 7 8 9 : ; <
			G910SendMessage(msg)
		end

		_,hasCooldown,_ = GetActionCooldown(i+60)	-- ActionBar6 = above AB1  (F1 thru F10 with gaps)
		if IsUsableAction(i+60) and hasCooldown<1.5 then
			G910cooldownMark[i+12] = 0
			msg = "!G" .. string.char(i+48+16)     -- send as green pixels, A B C D E F G H I J K L
			G910SendMessage(msg)
		else
			G910cooldownMark[i+12] = 1
			msg = "!G" .. string.char(i+48)     -- send as green pixels, 1 2 3 4 5 6 7 8 9 : ; <
			G910SendMessage(msg)
		end

		if i <= 6 then
			_,hasCooldown,_ = GetActionCooldown(i+48)	-- ActionBar5 = to right of AB6 (F11 thru "F15")
			if IsUsableAction(i+48) and hasCooldown<1.5 then
				G910cooldownMark[i+24] = 0
				msg = "!B" .. string.char(i+48+16)     -- send as blue pixels, A B C D E F G H I J K L
				G910SendMessage(msg)
			else
				G910cooldownMark[i+24] = 1
				msg = "!B" .. string.char(i+48)     -- send as blue pixels, 1 2 3 4 5 6 7 8 9 : ; <
				G910SendMessage(msg)
			end
		end 
	end
end
